import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";

/**************************************************
 * Created by nanyuantingfeng on 22/08/2017 21:57.
 **************************************************/
import path from 'path';
import fs from 'fs';
import mwBuild from './mwBuild';
import mwBabelOptions from './mwBabelOptions';
import mwPostCSSOptions from './mwPostCSSOptions';
import mwTSOptions from './mwTSOptions';
import mwDevServer from './mwDevServer';
import mwMultiEntryHTML from './mwMultiEntryHTML';
import mwPlugins from './mwPlugins';
import mwRules from './mwRules';
import mwENV from './mwENV';
import mwDLL from './mwDLL';

function noop() {
  return _noop.apply(this, arguments);
}

function _noop() {
  _noop = _asyncToGenerator(
  /*#__PURE__*/
  _regeneratorRuntime.mark(function _callee() {
    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this);
  }));
  return _noop.apply(this, arguments);
}

function getCustomConfig(cwd, config) {
  var _paths, _paths2, _paths3;

  if ('function' === typeof config) {
    return config;
  }

  var paths = [];

  switch (process.env.NODE_ENV) {
    case 'production':
      (_paths = paths).push.apply(_paths, ['build', 'production', 'prod']);

      break;

    case 'development':
      (_paths2 = paths).push.apply(_paths2, ['development', 'develop', 'dev']);

      break;

    case 'beta':
      (_paths3 = paths).push.apply(_paths3, ['beta', 'build', 'production', 'prod', 'development', 'develop', 'dev']);

      break;

    default:
      paths.push(process.env.NODE_ENV);
      break;
  }

  paths.push('config');
  paths = paths.map(function (name) {
    return "webpack.".concat(name, ".js");
  });
  config && paths.unshift(config);
  var cc = noop;
  var i = -1;

  while (++i < paths.length) {
    var p = paths[i];
    var pp = path.join(cwd, p);

    if (fs.existsSync(pp)) {
      console.log('>', pp);
      cc = require(pp);
      break;
    }
  }

  return cc;
}

export function mwsBuild(cwd, config) {
  var mwConfig = getCustomConfig(cwd, config);
  return [mwENV, mwBuild, mwMultiEntryHTML, mwDLL, mwPlugins, mwRules, mwBabelOptions, mwPostCSSOptions, mwTSOptions, mwConfig];
}
export function mwsDevServer(cwd, config) {
  var mwConfig = getCustomConfig(cwd, config);
  return [mwENV, mwBuild, mwMultiEntryHTML, mwDLL, mwPlugins, mwRules, mwBabelOptions, mwPostCSSOptions, mwTSOptions, mwDevServer, mwConfig];
}
export function mwsDLL(cwd, config) {
  var mwConfig = getCustomConfig(cwd, config);
  return [mwENV, mwBuild, mwDLL, mwPlugins, mwRules, mwBabelOptions, mwPostCSSOptions, mwTSOptions, mwConfig];
}